import importlib
import logging

logger = logging.getLogger(__name__)

TASKS = ["remove_data","register_extra","setup_os","unregister","install_daemon","afterinstall_checks","get_registration_info","remount","install_platform","debconf","register","remove_user","check_updates","nuke","update_platform","install_extras","check_key","restore_backup","install_drivers","install_features","setup_user","remove_legacy_platform","install_cranium","install_database","remove_old_repos","remove_platform"]

class Task (object):
    def __init__ (self, name, module):
        self._name = name
        self._module = module

    def __call__ (self, *args, **kwargs):
        logger.info("Running task: {}".format(self._name))
        return self._module.__call__(*args, **kwargs)

for task_name in TASKS:
    vars()[task_name] = Task(task_name, importlib.import_module(".{}".format(task_name), package=__name__))
